//------------------------------------------------------------------------------------------------
//
//   Project Blue - Pneumatic Extractor GUI Screen
//
//------------------------------------------------------------------------------------------------

package gcewing.projectblue;

import static java.lang.Math.*;

import gcewing.projectblue.BaseGui.*;
import static gcewing.projectblue.BaseGui.*;
import gcewing.projectblue.BaseGuiFields.*;
import gcewing.projectblue.BaseGuiColor.*;
import gcewing.projectblue.BaseGuiLayout.*;
import gcewing.projectblue.BaseDataChannel.*;

public class PneumaticExtractorScreen extends Screen {

	PneumaticExtractorPart part;

	public PneumaticExtractorScreen(PneumaticExtractorContainer container) {
		super(container, 128, 80);
		title = "Pneumatic Extractor";
		part = container.part;
		root.add(8, 16,
			new Grid(2,
				"Min Stack", new IntField(3, ref(part, "minStack")),
				"Max Stack", new IntField(3, ref(part, "maxStack")),
				"Interval", new FloatField(6, "%.2f", ref(this, "getSeconds", "setSeconds")),
				"Tag", new ColorField(ref(part, "tag"))
			)
		);
	}
	
	public double getSeconds() {
		return part.interval / 20.0;
	}
	
	public void setSeconds(double value) {
		part.interval = (int)round(value * 20.0);
	}

	@Override
	protected void onClose() {
		//System.out.printf("PneumaticExtractorScreen.onClose\n");
		ChannelOutput out = ProjectBlue.dataChannel.openServerContainer("update");
		out.writeInt(part.minStack);
		out.writeInt(part.maxStack);
		out.writeInt(part.interval);
		out.writeInt(part.tag);
		out.close();
	}
	
}
